<?php

// mirror.php
// v 0.2

$DEBUG=0;
/* Where should the named socket be created? 
 * Note: This directory shouldn't be readable by other users 
 */

$WRITE_DIR="/tmp/";

/* How many seconds do we wait before sending the Keep-Alive */
$KEEP_ALIVE=4;

// Get the tunnel info like mirror.php?s=A&d=B&m=r
$src=$_GET['s'];
$dst=$_GET['d'];
$mode=$_GET['m'];

if(isset($_GET['conf'])){
 $err=0;
 echo "<h2> Configuration menu </h2>";
 echo "<ul>";

 echo "<li>posix_mkfifo()...";
 if(function_exists("posix_mkfifo"))
   echo "<font color=\"green\">Ok</font>";
 else{
   echo "<font color=\"red\">NO</font>";
   $err=1;
 }
 echo "</li>";
 echo "<li>".$WRITE_DIR." writable...";
 if(posix_mkfifo($WRITE_DIR . "test",0600))
   echo "<font color=\"green\">Ok</font>";
 else{
   echo "<font color=\"red\">NO</font>";
   $err=1;
 }


 exit(0); 
}

// Security check
if(!( ereg("^[a-zA-Z]*$",$src) )){
  echo "Error";
  exit(0);
}
if(!( ereg("^[a-zA-Z]*$",$dst) )){
  echo "Error";
  exit(0);
}
if(!( ereg("^[rw]$",$mode) )){
  echo "Error";
  exit(0);
}
 


if($DEBUG){
 $log=fopen("log","a+");
 fwrite($log,"req: " . $src . ":" . $dst . ":" .$mode ."\n");
}
/*
 4 tunnel are to be used:
 A:B:r (used by B to read data)
 A:B:w (used by A to write data)
 B:A:r (used by A to read data)
 B:A:w (user by B to write data)
*/


$path_s= $WRITE_DIR . "pipe" . $src . "_" . $dst;

/*
 Create the fifo
*/

if(! file_exists($path_s)){
  posix_mkfifo($path_s,0600);
  if ($DEBUG)
    fwrite($log,"Pipe: " . $path_s . " created" . "\n");
}

/*
 Open the fifo
 ( Mode is append [r+|w+] )
*/

$pipe = fopen($path_s,$mode."+");

if ( $mode=="r" ){

  $w = $e = NULL;

  /*
   Print content or keep-alive)
  */

  header('Content-type: text/html');
  ob_flush();
  print("\n");
  /* Force flush to ensure chuncked encoding */
  flush();

  while (1){
    $read=array($pipe);
    // We set a Timeout to keep-alive
    $n = stream_select($read,$w,$e,$KEEP_ALIVE);

    if ( $n > 0){
      $data = fgets($pipe);
      print($data);
      flush();
      if($DEBUG){
        fwrite($log,"read < ". $data);
        fflush($log);
      }

    }else{
      // Keep Alive
      print("\n");
      flush();
    }
  }

}else if($mode == "w") {
   $s = fopen("php://input","r+");
   $data = fgets($s);
   fwrite($pipe,$data);
   fflush($pipe);
   if($DEBUG){
     fwrite($log,"write > ". $data);
     fflush($log);
   }
   /* Return an acknowledge that data was written */
   print("Ok\n");
}
?>
